* ============================================================
*   Nom de la base   :  MCD_HOTEL                             
*   Nom de SGBD      :  dBASE 5.0 pour Windows                
*   Date de cration :  16/01/2001  22:29 
*   Copyright        : Frdric BROUARD                                         
* ============================================================

SET SAFETY OFF
SET TALK OFF
CLOSE ALL
CLEAR ALL
TempoStru = "__AMCD__"
KeepTable = ""
ColNum = 0
IndexNo = 0
IndexExpr = ""
IndexFirst = ""
DECLARE KeepCol[100]

* ============================================================
*   Table : T_CHAMBR                                          
* ============================================================
OpenTable("T_CHAMBR")
TableAddColumn("CHB_ID", "N", 0, 0)
TableAddColumn("CHB_NUMERO", "N", 0, 0)
TableAddColumn("CHB_ETAGE", "C3", 3, 0)
TableAddColumn("CHB_BAIN", "L", 0, 0)
TableAddColumn("CHB_DOUCHE", "L", 0, 0)
TableAddColumn("CHB_WC", "L", 0, 0)
TableAddColumn("CHB_COUCHA", "N", 0, 0)
TableAddColumn("CHB_POSTE_", "C3", 3, 0)
EndTable()

* ============================================================
*   Index : T_CHAMBR                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CHB_ID",1)
CreateIndex("T_CHAMBR", "  UNIQUE")

* ============================================================
*   Table : T_TARIF                                           
* ============================================================
OpenTable("T_TARIF")
TableAddColumn("TRF_DATE_D", "D", 0, 0)
TableAddColumn("TRF_TAUX_T", "N", 0, 0)
TableAddColumn("TRF_PETIT_", "N", 0, 0)
EndTable()

* ============================================================
*   Index : T_TARIF_                                          
* ============================================================
IndexNo = 0
IndexAddColumn("TRF_DATE_D",1)
CreateIndex("T_TARIF_", "  UNIQUE")

* ============================================================
*   Table : T_PLANNI                                          
* ============================================================
OpenTable("T_PLANNI")
TableAddColumn("PLN_JOUR", "D", 0, 0)
EndTable()

* ============================================================
*   Index : T_PLANNI                                          
* ============================================================
IndexNo = 0
IndexAddColumn("PLN_JOUR",1)
CreateIndex("T_PLANNI", "  UNIQUE")

* ============================================================
*   Table : T_TITRE                                           
* ============================================================
OpenTable("T_TITRE")
TableAddColumn("TIT_CODE", "C8", 8, 0)
TableAddColumn("TIT_LIBELL", "C32", 32, 0)
EndTable()

* ============================================================
*   Index : T_TITRE_                                          
* ============================================================
IndexNo = 0
IndexAddColumn("TIT_CODE",1)
CreateIndex("T_TITRE_", "  UNIQUE")

* ============================================================
*   Table : T_TYPE                                            
* ============================================================
OpenTable("T_TYPE")
TableAddColumn("TYP_CODE", "C8", 8, 0)
TableAddColumn("TYP_LIBELL", "C32", 32, 0)
EndTable()

* ============================================================
*   Index : T_TYPE_P                                          
* ============================================================
IndexNo = 0
IndexAddColumn("TYP_CODE",1)
CreateIndex("T_TYPE_P", "  UNIQUE")

* ============================================================
*   Table : T_MODE_P                                          
* ============================================================
OpenTable("T_MODE_P")
TableAddColumn("PMT_CODE", "C8", 8, 0)
TableAddColumn("PMT_LIBELL", "C64", 64, 0)
EndTable()

* ============================================================
*   Index : T_MODE_P                                          
* ============================================================
IndexNo = 0
IndexAddColumn("PMT_CODE",1)
CreateIndex("T_MODE_P", "  UNIQUE")

* ============================================================
*   Table : T_CLIENT                                          
* ============================================================
OpenTable("T_CLIENT")
TableAddColumn("CLI_ID", "N", 0, 0)
TableAddColumn("TIT_CODE", "C8", 8, 0)
TableAddColumn("CLI_NOM", "C32", 32, 0)
TableAddColumn("CLI_PRENOM", "C25", 25, 0)
TableAddColumn("CLI_ENSEIG", "C100", 100, 0)
EndTable()

* ============================================================
*   Index : T_CLIENT                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CLI_ID",1)
CreateIndex("T_CLIENT", "  UNIQUE")

* ============================================================
*   Index : L_CLI_TI                                          
* ============================================================
IndexNo = 0
IndexAddColumn("TIT_CODE",2)
CreateIndex("L_CLI_TI", "  ")

* ============================================================
*   Table : T_FACTUR                                          
* ============================================================
OpenTable("T_FACTUR")
TableAddColumn("FAC_ID", "N", 0, 0)
TableAddColumn("CLI_ID", "N", 0, 0)
TableAddColumn("PMT_CODE", "C8", 8, 0)
TableAddColumn("FAC_DATE", "D", 0, 0)
TableAddColumn("FAC_PMT_DA", "D", 0, 0)
EndTable()

* ============================================================
*   Index : T_FACTUR                                          
* ============================================================
IndexNo = 0
IndexAddColumn("FAC_ID",1)
CreateIndex("T_FACTUR", "  UNIQUE")

* ============================================================
*   Index : L_FAC_CL                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CLI_ID",2)
CreateIndex("L_FAC_CL", "  ")

* ============================================================
*   Index : TJ_FAC_P                                          
* ============================================================
IndexNo = 0
IndexAddColumn("PMT_CODE",3)
CreateIndex("TJ_FAC_P", "  ")

* ============================================================
*   Table : T_ADRESS                                          
* ============================================================
OpenTable("T_ADRESS")
TableAddColumn("ADR_ID", "N", 0, 0)
TableAddColumn("CLI_ID", "N", 0, 0)
TableAddColumn("ADR_LIGNE1", "C32", 32, 0)
TableAddColumn("ADR_LIGNE2", "C32", 32, 0)
TableAddColumn("ADR_LIGNE3", "C32", 32, 0)
TableAddColumn("ADR_LIGNE4", "C32", 32, 0)
TableAddColumn("ADR_CP", "C5", 5, 0)
TableAddColumn("ADR_VILLE", "C32", 32, 0)
EndTable()

* ============================================================
*   Index : T_ADRESS                                          
* ============================================================
IndexNo = 0
IndexAddColumn("ADR_ID",1)
CreateIndex("T_ADRESS", "  UNIQUE")

* ============================================================
*   Index : L_ADR_CL                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CLI_ID",2)
CreateIndex("L_ADR_CL", "  ")

* ============================================================
*   Table : T_TELEPH                                          
* ============================================================
OpenTable("T_TELEPH")
TableAddColumn("TEL_ID", "N", 0, 0)
TableAddColumn("CLI_ID", "N", 0, 0)
TableAddColumn("TYP_CODE", "C8", 8, 0)
TableAddColumn("TEL_NUMERO", "C20", 20, 0)
TableAddColumn("TEL_LOCALI", "C64", 64, 0)
EndTable()

* ============================================================
*   Index : T_TELEPH                                          
* ============================================================
IndexNo = 0
IndexAddColumn("TEL_ID",1)
CreateIndex("T_TELEPH", "  UNIQUE")

* ============================================================
*   Index : L_TEL_CL                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CLI_ID",2)
CreateIndex("L_TEL_CL", "  ")

* ============================================================
*   Index : L_TEL_TY                                          
* ============================================================
IndexNo = 0
IndexAddColumn("TYP_CODE",3)
CreateIndex("L_TEL_TY", "  ")

* ============================================================
*   Table : T_EMAIL                                           
* ============================================================
OpenTable("T_EMAIL")
TableAddColumn("EML_ID", "N", 0, 0)
TableAddColumn("CLI_ID", "N", 0, 0)
TableAddColumn("EML_ADRESS", "C100", 100, 0)
TableAddColumn("EML_LOCALI", "C64", 64, 0)
EndTable()

* ============================================================
*   Index : T_EMAIL_                                          
* ============================================================
IndexNo = 0
IndexAddColumn("EML_ID",1)
CreateIndex("T_EMAIL_", "  UNIQUE")

* ============================================================
*   Index : L_EML_CL                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CLI_ID",2)
CreateIndex("L_EML_CL", "  ")

* ============================================================
*   Table : T_LIGNE_                                          
* ============================================================
OpenTable("T_LIGNE_")
TableAddColumn("LIF_ID", "N", 0, 0)
TableAddColumn("FAC_ID", "N", 0, 0)
TableAddColumn("LIF_QTE", "N", 0, 0)
TableAddColumn("LIF_REMISE", "N", 0, 0)
TableAddColumn("LIF_REMIS2", "N", 0, 0)
TableAddColumn("LIF_MONTAN", "N", 0, 0)
TableAddColumn("LIF_TAUX_T", "N", 0, 0)
EndTable()

* ============================================================
*   Index : T_LIGNE_                                          
* ============================================================
IndexNo = 0
IndexAddColumn("LIF_ID",1)
CreateIndex("T_LIGNE_", "  UNIQUE")

* ============================================================
*   Index : L_LIF_FA                                          
* ============================================================
IndexNo = 0
IndexAddColumn("FAC_ID",2)
CreateIndex("L_LIF_FA", "  ")

* ============================================================
*   Table : TJ_TRF_C                                          
* ============================================================
OpenTable("TJ_TRF_C")
TableAddColumn("CHB_ID", "N", 0, 0)
TableAddColumn("TRF_DATE_D", "D", 0, 0)
TableAddColumn("TRF_CHB_PR", "N", 0, 0)
EndTable()

* ============================================================
*   Index : TJ_TRF_C                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CHB_ID",1)
IndexAddColumn("TRF_DATE_D",2)
CreateIndex("TJ_TRF_C", "  UNIQUE")

* ============================================================
*   Index : L_CHB_TR                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CHB_ID",1)
CreateIndex("L_CHB_TR", "  ")

* ============================================================
*   Index : L_TRF_CH                                          
* ============================================================
IndexNo = 0
IndexAddColumn("TRF_DATE_D",2)
CreateIndex("L_TRF_CH", "  ")

* ============================================================
*   Table : TJ_CHB_P                                          
* ============================================================
OpenTable("TJ_CHB_P")
TableAddColumn("CHB_ID", "N", 0, 0)
TableAddColumn("PLN_JOUR", "D", 0, 0)
TableAddColumn("CLI_ID", "N", 0, 0)
TableAddColumn("CHB_PLN_CL", "N", 0, 0)
TableAddColumn("CHB_PLN_C2", "L", 0, 0)
TableAddColumn("CHB_PLN_C3", "L", 0, 0)
EndTable()

* ============================================================
*   Index : TJ_CHB_P                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CHB_ID",1)
IndexAddColumn("PLN_JOUR",2)
CreateIndex("TJ_CHB_P", "  UNIQUE")

* ============================================================
*   Index : L_CHB_PL                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CHB_ID",1)
CreateIndex("L_CHB_PL", "  ")

* ============================================================
*   Index : L_PLN_CH                                          
* ============================================================
IndexNo = 0
IndexAddColumn("PLN_JOUR",2)
CreateIndex("L_PLN_CH", "  ")

* ============================================================
*   Index : L_CLI_CH                                          
* ============================================================
IndexNo = 0
IndexAddColumn("CLI_ID",3)
CreateIndex("L_CLI_CH", "  ")


USE
IF ISTABLE(TempoStru)
   DELETE TABLE &TempoStru
ENDIF
CLEAR ALL
RETURN

PROCEDURE OpenTable(TabName)
    ? "Cration de "+TabName
    IF ISTABLE(TempoStru)
       DELETE TABLE &TempoStru
    ENDIF
    KeepTable = TabName
    CREATE &TempoStru STRUCTURE EXTENDED
    ColNum = 0
RETURN

PROCEDURE TableAddColumn(ColName, ColType, ColLen, ColPrec)
    ColNum = ColNum + 1
    APPEND BLANK
    REPLACE Field_Name WITH ColName
    REPLACE Field_Type WITH ColType
    REPLACE Field_Len  WITH ColLen
    REPLACE Field_Dec  WITH ColPrec
    REPLACE Field_Idx  WITH "N"
    KeepCol[ColNum] = ColType
RETURN

PROCEDURE EndTable
    CREATE &KeepTable FROM &TempoStru TYPE DBASE
RETURN

PROCEDURE IndexAddColumn(ColName, ColNo)
    ColType = KeepCol[ColNo]
    IF ColType # "G" .AND. ColType # "B" .AND. ColType # "M" .AND. ColType # "L"
       IF IndexNo = 0
          IndexFirst = ColType
          IndexExpr = ColName
       ELSE
          IF IndexNo = 1
             IF IndexFirst = "N" .OR. IndexFirst = "F"
                IndexExpr = "STR("+IndexExpr+")"
             ELSEIF IndexFirst = "D"
                IndexExpr = "DTOC("+IndexExpr+")"
             ENDIF
          ENDIF
          IF ColType = "N" .OR. ColType = "F"
             IndexExpr = IndexExpr+"+STR("+ColName+")"
          ELSEIF ColType = "D"
             IndexExpr = IndexExpr+"+DTOC("+ColName+")"
          ELSE
             IndexExpr = IndexExpr+"+"+ColName
          ENDIF
       ENDIF
       IndexNo = IndexNo + 1
    ENDIF
RETURN

PROCEDURE CreateIndex(IdxName, IdxOption)
    IF "" # IndexExpr
       ? "Cration de l'index "+IdxName+" sur "+IndexExpr
       Stmt = "INDEX ON "+IndexExpr+" TAG "+IdxName+" "+IdxOption
       &Stmt
    ENDIF
RETURN
